Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_EC_Filter Class Reference

Abstract base class for the filter hierarchy. More...

`#include <EC_Filter.h>`

Inheritance diagram for TAO_EC_Filter

[legend]
Collaboration diagram for TAO_EC_Filter:

[legend]
List of all members.

## Public Types
typedef TAO_EC_Filter* | value_type
typedef TAO_EC_Filter* const | const_value_type
typedef const_value_type* | ChildrenIterator
## Public Methods
| TAO_EC_Filter (void)
| constructor...
virtual | ~TAO_EC_Filter (void)
| destructor...
TAO_EC_Filter* | parent (void) const
| Obtain the parent of this filter.
void | adopt_child (TAO_EC_Filter* child)
| Become the parent of <child>.
virtual ChildrenIterator | begin (void) const
virtual ChildrenIterator | end (void) const
virtual int | size (void) const
virtual int | filter (const RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env) = 0
virtual int | filter_nocopy (RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env) = 0
virtual void | push (const RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env) = 0
virtual void | push_nocopy (RtecEventComm::EventSet& event, TAO_EC_QOS_Info& qos_info, CORBA::Environment& env) = 0
virtual void | clear (void) = 0
| Clear any saved state, must reset and assume no events have been received.
virtual CORBA::ULong | max_event_size (void) const = 0
| Returns the maximum size of the events pushed by this filter.
virtual int | can_match (const RtecEventComm::EventHeader& header) const = 0
virtual int | add_dependencies (const RtecEventComm::EventHeader& header, const TAO_EC_QOS_Info& qos_info, CORBA::Environment &ACE_TRY_ENV) = 0
virtual void | get_qos_info (TAO_EC_QOS_Info& qos_info, CORBA::Environment &ACE_TRY_ENV)
## Static Public Methods
int | matches (const RtecEventComm::EventHeader& rhs, const RtecEventComm::EventHeader& lhs)
| matches two event headers. More...
## Private Attributes
TAO_EC_Filter* | parent_
| The parent...

## Detailed Description

Abstract base class for the filter hierarchy.

The per-consumer filtering mechanisms. The EC needs to filter data passed to the consumers, so it can correctly satisfy its subscription requirements. This filtering can include correlations, sequences, timeouts, etc. each consumer can request different filtering criteria. Different filtering objects are associated with each consumer, the filters are organized in a hierarchical structure, corresponding to the subscription "expression" that the events must satisfy. The hierarchy is constructed using the "Builder" pattern.

## Memory Management

It does *not* assume ownership of its parent.

## Member Typedef Documentation

typedef const_value_type* TAO_EC_Filter::ChildrenIterator

typedef TAO_EC_Filter* const TAO_EC_Filter::const_value_type

typedef TAO_EC_Filter* TAO_EC_Filter::value_type

## Constructor & Destructor Documentation

ACE_INLINE TAO_EC_Filter::TAO_EC_Filter ( | void )

| constructor...

TAO_EC_Filter::~TAO_EC_Filter ( | void )`[virtual]`

| destructor...

## Member Function Documentation

int TAO_EC_Filter::add_dependencies ( | const RtecEventComm::EventHeader & header,
| const TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[pure virtual]`

| This is used for computing the scheduling dependencies: Leaf filters check if the header could be matched, similar to the can_match() method; if it does they return 1, and 0 otherwise. Intermediate nodes always return 0. This is used to build precise dependencies between the suppliers and the leaf of the filters that accept that event. Notice that only the nodes doing scheduling recurse through the list, so in configurations that do no require scheduling the recursion stops fairly soon. Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

void TAO_EC_Filter::adopt_child ( | TAO_EC_Filter * child )

| Become the parent of <child>.

ChildrenIterator TAO_EC_Filter::begin ( | void ) const`[virtual]`

| STL-like iterators Filters follow the Composite pattern. All filters expose the same interface as if they all had children, but for simple filters the iterators return an empty range. Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, and TAO_EC_Sched_Filter.

int TAO_EC_Filter::can_match ( | const RtecEventComm::EventHeader & header ) const`[pure virtual]`

| Returns 0 if an event with that header could never be accepted. This can used by the suppliers to filter out consumers that couldn't possibly be interested in their events. The rt_info and Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

void TAO_EC_Filter::clear ( | void )`[pure virtual]`

| Clear any saved state, must reset and assume no events have been received. Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

TAO_EC_Filter::ChildrenIterator TAO_EC_Filter::end ( | void ) const`[virtual]`

| Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, and TAO_EC_Sched_Filter.

int TAO_EC_Filter::filter ( | const RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[pure virtual]`

| Filter this event, returns 1 if the event is accepted, 0 otherwise. Notice that there are two versions of the method, if the event is not const then filter can take ownership of the event. Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

virtual int TAO_EC_Filter::filter_nocopy ( | RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[pure virtual]`

| Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

void TAO_EC_Filter::get_qos_info ( | TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[virtual]`

| Obtain the QOS information for this filter, the default implementation returns an invalid QOS. Only the filters that support scheduling information implement this method. Returns 0 on success and -1 on failure Reimplemented in TAO_EC_Sched_Filter.

ACE_INLINE int TAO_EC_Filter::matches ( | const RtecEventComm::EventHeader & rhs,
| const RtecEventComm::EventHeader & lhs )`[static]`

| matches two event headers. Todo: Should we strategize the algorithm used to match headers?

CORBA::ULong TAO_EC_Filter::max_event_size ( | void ) const`[pure virtual]`

| Returns the maximum size of the events pushed by this filter. Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

ACE_INLINE TAO_EC_Filter * TAO_EC_Filter::parent ( | void ) const

| Obtain the parent of this filter.

void TAO_EC_Filter::push ( | const RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[pure virtual]`

| This is called by the children when they accept an event and which to pass it up. Notice that there are two versions of the method, if the event is not const then filter can take ownership of the event. Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

virtual void TAO_EC_Filter::push_nocopy ( | RtecEventComm::EventSet & event,
| TAO_EC_QOS_Info & qos_info,
| CORBA::Environment & ACE_TRY_ENV )`[pure virtual]`

| Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Null_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, TAO_EC_Sched_Filter, TAO_EC_Timeout_Filter, and TAO_EC_Type_Filter.

int TAO_EC_Filter::size ( | void ) const`[virtual]`

| Reimplemented in TAO_EC_And_Filter, TAO_EC_Bitmask_Filter, TAO_EC_Conjunction_Filter, TAO_EC_Disjunction_Filter, TAO_EC_Masked_Type_Filter, TAO_EC_Negation_Filter, and TAO_EC_Sched_Filter.

## Member Data Documentation

TAO_EC_Filter * TAO_EC_Filter::parent_`[private]`

| The parent...

The documentation for this class was generated from the following files:

- EC_Filter.h
- EC_Filter.cpp
- EC_Filter.i